--[[
 file name .    List.lua
 author  .      李天录
 created .      1.23.2015
 purpose .      双向队列
--]]

module("List", package.seeall)

function newList()
    local first = 1
    local last = 0
    local list = {}
	local listManager = {}
    function listManager.pushFront(obj)
        if nil~=obj then
            first = first - 1
            list[first] = obj
        end
    end
    function listManager.pushBack(obj)
        if nil~=obj then
            last = last + 1
            list[last] = obj
        end
    end
    function listManager.peekFront()
        local val = list[first]
        return val
    end
    function listManager.peekBack()
        local val = list[last]
        return val
    end
    function listManager.popFront()
        local obj=nil
        if first<=last then
            obj=list[first]
            list[first] = nil
            first=first+1
        end
        return obj
    end
    function listManager.popBack()
        local obj=nil 
        if first<=last then
            obj=list[last]
            list[last] = nil            
            last=last-1
        end
        return obj
    end
    function listManager.clear()
        list={}
        first=1
        last=0
    end
    function listManager.isEmpty()
        if first>last then
            return true
        else
            return false
        end
    end
    function listManager.getSize()
        if  first>last then
            return 0
        else
            return last-first+1
        end
    end
    return listManager
end


--[[
--local List=require "List"
List=_M
do
    local lst=List.newList()
    lst.pushBack("123")
    lst.pushBack("1231")
    lst.pushFront("77")
    t=lst.popBack() print(t)
    t=lst.popFront()print(t)
    lst.clear()
    t=lst.popBack();
    print(t)
    lst.pushBack({})
    t=lst.popBack();
    print(t)

    for k,v in pairs(lst) do
        print(k,v)
    end
end
--]]