---[[
module("Tasks_CLS", package.seeall)

Tasks_CLS={}

function New()
    local mt=Tasks_CLS
	local self={}
    setmetatable(self,mt)
    mt.__index = mt
	self.m_Threads={}
    return self
end

function Tasks_CLS:Add(cTask)
	assert(type(cTask)=="thread","Tasks_CLS:Add(?) need type thread")
	self.m_Threads[cTask]=true
end

function Tasks_CLS:OnTime()
	for k,v in pairs(self.m_Threads) do
		local status,info=coroutine.resume(k)
		if status==false and PrintString then
			PrintString(info)
		end
		if coroutine.status(k)=="dead" then
			self.m_Threads[k]=nil
		end
	end
end

function Tasks_CLS:IsEmpty()
	local Result=true
	for k,v in pairs(self.m_Threads) do
		Result=false
		break
	end
	return Result
end

-------------------------------------------------------------------------------
--[[
print("-----Tasks Test Begin----")
--require("Tasks")
local Tasks_CLS=_M

local Tasks=Tasks_CLS.New()

local fTest = function ( a,b )
	print(a)
	coroutine.yield()
	print(b)
end

Tasks:Add(coroutine.create(function ()
		fTest("f1-11","f1-22")
	end))
Tasks:Add(coroutine.create(function ()
		fTest("f2-11","f2-22")
		fTest("f2-33","f2-44")
	end))

while Tasks:IsEmpty()==false do
	Tasks:OnTime()
end

for k,v in pairs(Tasks.m_Threads) do
	print(k,v)
end

print("-----Tasks Test End----")
--]]
