
--package.path = package.path..";./luaScript/?.lua;./lua/?.lua;d:/lua/?.lua"
--package.cpath = package.cpath..";./luaScript/?.dll;./lua/?.dll;d:/lua/?.dll"

json=require "cjson"
mx=require("mx")
Tasks=require("Tasks")
LxATP=require("LxATP")
List=require("List")

function string.split(str, delimiter)
    if str==nil or str=='' or delimiter==nil then
        return nil
    end
    
    local result = {}
    for match in (str..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end

function string.hex2bin(hexstr)
    local t = {}
    for i = 1, string.len(hexstr) - 1, 2 do
        local doublebytestr = string.sub(hexstr, i, i+1);
        local n = tonumber(doublebytestr, 16);
        table.insert(t,string.char(n))
    end
    return table.concat(t)
end

function string.bin2hex( binstr )
	return (string.gsub(binstr, ".",function(c) return string.format("%02X", string.byte(c)) end))
end

Comm=
{
	CopyTab=nil,
	GetTimeMsec=function() return App.m_CurTimeMsec end,
	NewTimer=function()
		local Timer = mx.mxTimerMsec_CLS()
		Timer:Init(App.m_CurTimeMsec)
		return Timer
	end,
	AddTaskFun=function(fn) return App.m_Tasks:Add(coroutine.create(fn)) end,
	AddTaskCoroutine=function(co) return App.m_Tasks:Add(co) end,
	SendData2C=function(Type,Data) return C4Lua.Lua2C(Type,Data) end,
	YieldSleep=function(MsecTimeOut,Timer) end,	
	Resume=function(...)
		local status,info=coroutine.resume(...)
		if status==false and PrintString then
			PrintString(info)
		end
		return status,info
	end,
	MyPCall=function(fn)
		return function(...)
			local status,info=pcall(fn,...)
			if status==false and PrintString then
				PrintString(info)
			end		
		end
	end,
	TimeZoneSec=3600*24-os.time({year=1970, month=1, day=2, hour=0}),
}


function Comm.CopyTab(st)
	local CopyTab = Comm.CopyTab
    local tab = {}
    for k, v in pairs(st or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = CopyTab(v)
        end
    end
    return tab
end

function Comm.YieldSleep(MsecTimeOut,Timer)
	local Comm = App.m_Comm	
	local Timer=Timer
	if Timer==nil then
		Timer=Comm.NewTimer()
	end
	Timer:ResetTimer()
	while true do
		Timer:UpdateTimer()
		if Timer:GetTimerMsec()>=MsecTimeOut then
			break
		end
		coroutine.yield()
	end
	return Timer
end

