if not LuaPath then
    LuaPath="."
end
package.path = string.format("%s/?.lua;%s/luaScript/?.lua",LuaPath,LuaPath)
if string.sub(package.cpath,-3,-1)==".so" then
    package.cpath = string.format("%s/?.so;%s/luaScript/?.so",LuaPath,LuaPath)
else
    package.cpath = string.format("%s/?.dll;%s/luaScript/?.dll",LuaPath,LuaPath)
end

require("appComm")

App={
	m_CurTimeMsec=mx.mxTimeMsec_CLS(),
	m_Tasks=Tasks_CLS.New(),
	m_Config={},--里面的所有参数配置来自于appConfig/appConfig.lua	
	m_Comm=Comm,
    m_DevDataTable={
        ["000F867967020630401B"]={
            DaySteps={
                Date="2015-12-29",
                HourSteps={
                    --[0]=0,
                    --[1]=0,
                },
                Status=nil,
            },
        },
    },
	m_ServiceForUI={
        Init=function(self) end,
        OnTime=function(self) end,
        Ref={
        	CallBackOnReceive=function(CmdType,CmdData)
                App.m_ServiceForDebug:PutData("Callbak:"..CmdType..","..CmdData.."\r\n")
                PrintString("Callbak:"..CmdType..","..CmdData)
                C4Lua.Lua2C(CmdType,CmdData)
            end,--SDK回调
            Connect=function() return App.m_AccountManager:Connect(App.m_Config.AppServer,App.m_Config.AppServerPort) end,
            DisConnect=function() return App.m_AccountManager:DisConnect() end,  
            SendPktToServer=function(Pkt) return App.m_AccountManager:SendPktToServer(Pkt) end,
            GetDevDataTable=function() return App.m_DevDataTable end,
            SetRxFunc=function(Func,Valid) return App.m_AccountManager:SetRxFunc(Func,Valid) end,
            VirtualDevCtrl=function(CtrlObj) return App.m_VirtualDevice:VirtualDevCtrl(CtrlObj) end,
            SqliteTest=function(Obj) return App.m_Sqlite:SqliteTest(Obj) end,
        },
        PutCmdData=function(self,CmdType,CmdData) end,--SDK接口
        GetDevData=function(self,DevID,AutoCreat) end,   
        --private:
        m_UserConfig={Params={},},--参数配置
	},
    m_AccountManager={
        Ref={
            CallBackOnReceive=function(CmdType,CmdData)
                App.m_ServiceForDebug:PutData("Callbak:"..CmdType..","..CmdData.."\r\n")
                --PrintString("Callbak:"..CmdType..","..CmdData)            
                C4Lua.Lua2C(CmdType,CmdData)
            end,--SDK回调
            GetDevEventInfo=function(Obj) return App.m_Sqlite:GetDevEventInfo(Obj) end,
            SaveDevEventInfo=function(Obj) return App.m_Sqlite:SaveDevEventInfo(Obj) end,
        },
        Connect=function(self,NetAddr,Port) end,
        DisConnect=function(self) end, 
        SendPktToServer=function(self,Pkt) end,
        OnTime=function(self) end,--检测处理协程是否正常
        SetRxFunc=function(self,Func,Valid) end,
        --private:
        m_RxFuncTable={},
        m_CoParam={},--处理协程的各种参数
        YieldSendPkt=function(self,CoParam,Pkt) end,
        OnRxData=function(self,CoParam,Data) end,
        OnRxPkt=function(self,CoParam,Pkt) end,
    },
    m_VirtualDevice={
        Ref={
            SendPktToServer=function(Pkt) return App.m_AccountManager:SendPktToServer(Pkt) end,
            CallBackOnReceive=function(CmdType,CmdData)
                App.m_ServiceForDebug:PutData("Callbak:"..CmdType..","..CmdData.."\r\n")
                PrintString("Callbak:"..CmdType..","..CmdData)
                C4Lua.Lua2C(CmdType,CmdData)                
            end,--SDK回调
            SetRxFunc=function(Func,Valid) return App.m_AccountManager:SetRxFunc(Func,Valid)  end,
            GetServerAddr=function() return App.m_Config.DeviceServer,App.m_Config.DeviceServerPort end,
        },
        Init=function(self) end,
        OnTime=function(self) end,
        VirtualDevCtrl=function(self,CtrlObj) end,
        --private:
        Register=function(self) end,
        Open=function (self) end,
        Close=function (self) end,
        SendPosition=function(self,Position) end,
        m_Data={},
    },
    m_ServiceForDebug={
        Ref={
            PutCmdData=function(CmdType,CmdData) return App.m_ServiceForUI:PutCmdData(CmdType,CmdData) end,
            CallBackOnReceive=function(CmdType,CmdData)
                App.m_ServiceForDebug:PutData("Callbak:"..CmdType..","..CmdData.."\r\n")
                PrintString("Callbak:"..CmdType..","..CmdData)
                C4Lua.Lua2C(CmdType,CmdData)                 
            end,--SDK回调
        },
        Init=function() end,
        PutData=function(self,Data) end,
        m_NetClient,
    },
    m_Sqlite={
        Init=function() end,
        OnTime=function() end,
        GetDevEventInfo=function(self,Obj) end,
        SaveDevEventInfo=function(self,Obj) end,
        SqliteTest=function(self,Obj) end,
    },
}

require("appConfig")
require("appLua4C")
require("appServiceForUI")
require("appAccountManager")
require("appServiceForDebug")
require("appVirtualDevice")
require("appSqlite")

PrintString("runnig ...");
print("runing...")

