local This 

if App then
	This=App.m_ServiceForDebug
else
	This={}
end

function This:Init()
	PrintString("ServiceForDebug:Init()")
	self.NetServer=mx.mxNetServer_CLS()
	self.NetServer:Init(Comm.GetTimeMsec())
	self.NetServer:SetInput(0,12315)
	self.NetServer:Open()
end

function This:OnTime()
	self.NetServer:OnTime()
	local IsOpen,IsConnectOK=self.NetServer:GetOutput()
	if 1==IsConnectOK then		
		local NetClient = mx.mxNetClient_CLS()
		NetClient:Init(Comm.GetTimeMsec())
		NetClient:Open(self.NetServer:GetClientSocket())
		PrintString("ServiceForDebug Socket Connect")
		if self.m_NetClient then
			self.m_NetClient:Close()
		end
		self.m_NetClient=NetClient
		Comm.AddTaskFun(function ()
			local Timer = mx.mxTimerMsec_CLS()
			Timer:Init(Comm.GetTimeMsec())
			local RawRx=""
			local IsConnectOK
			while true do
				NetClient:OnTime()
				local Data=NetClient:GetData()
				if Data and Data:len()>0 then
					RawRx=RawRx..Data
					Timer:ResetTimer()
				end
				Timer:UpdateTimer()
				if RawRx:len()>0 and Timer:GetTimerMsec() > 200 then
					self:YiledProcessRxPkt(RawRx,NetClient)
					RawRx=""
				end
				_,IsConnectOK=NetClient:GetOutput()
				if IsConnectOK~=1 then
					PrintString("ServiceForDebug Socket Break")
					break
				end
				coroutine.yield()
			end
			NetClient:Close()
			self.m_NetClient=nil
		end)
	end
end

function This:YiledProcessRxPkt(Pkt,NetClient)
	NetClient:PutData("RxData:"..Pkt.."\r\n")
	local Type,Data=string.match(Pkt,"(%w+),(.+)")
	if "1"==Type or "2"==Type then
		local Str=self.Ref.PutCmdData(tonumber(Type),Data)
		if type(Str)=="string" then
			NetClient:PutData("return:"..Str.."\r\n")
		end
	elseif 'R'==Type then
		local Type,Data=string.match(Data,"(%w+),(.+)")
		self.Ref.CallBackOnReceive(tonumber(Type),Data)
	elseif "Test"==Type then
		for i=1,100 do
			local Str=self.Ref.PutCmdData(2,Data)
			if type(Str)=="string" then
				NetClient:PutData("return:"..Str.."\r\n")
			end
		end
	end
end

function This:PutData(Data)
	local NetClient=self.m_NetClient
	if NetClient then
		local Data=Data
		local _,IsConnectOK=NetClient:GetOutput()
		while IsConnectOK==1 do
			local n=NetClient:PutData(Data)
			if n~=#Data then
				Data=string.sub(Data,n+1,-1)
			else
				break
			end
			_,IsConnectOK=NetClient:GetOutput()
		end
	end
end
