
-------------以下区间内的代码为本文件的公共部分，一般无需修改---------------------V

json=require "cjson"

local function TimeZoneAdd(SrcTime,AddTimeZone)
	local Y,m,d,H,M,S = string.match(SrcTime,"(%d+)-(%d+)-(%d+) (%d+):(%d+):(%d+)")
	LocalTime=os.time{year=tonumber(Y), month=tonumber(m), day=tonumber(d), hour=tonumber(H),min=tonumber(M),sec=tonumber(S)}
	LocalTime=LocalTime+AddTimeZone*3600
	local Time=os.date("%Y-%m-%d %H:%M:%S",LocalTime)
	return Time,LocalTime
end

local This
if App then
	This=App.m_ServiceForUI
else
	This={} --方便单文件检测语法错误
end

This.m_CmdTypeFunc={}
local m_CmdTypeFunc = This.m_CmdTypeFunc

function This:Init()
	if LuaPath then	
		local IsUserDefaultConfig=true
		while true do
			local RdFile=io.open(LuaPath.."/UserConfig.json","r")
			if not RdFile then break end
			local FileData=RdFile:read("*a")
			io.close(RdFile)
			local status,Obj=pcall(json.decode,FileData)
			if status then
				self.m_UserConfig=Obj
				--
				if Obj.Params.AppServer then
					App.m_Config.AppServer=Obj.Params.AppServer
				else
					Obj.Params.AppServer=App.m_Config.AppServer
				end
				if Obj.Params.AppServerPort then
					App.m_Config.AppServerPort=Obj.Params.AppServerPort
				else
					Obj.Params.AppServerPort=App.m_Config.AppServerPort
				end
				IsUserDefaultConfig=false
			end
		break end
		if IsUserDefaultConfig then
			self.m_UserConfig={
				Params={
					AppServer=App.m_Config.AppServer,
					AppServerPort=App.m_Config.AppServerPort,
				 }
			}
		end 
	end
end

function This:PutCmdData(CmdType,CmdData)
	local Result=""
	while true do
		PrintString("PutCmdData:"..CmdType..","..CmdData)
		if 1==CmdType or 2==CmdType then
			local status,Obj=pcall(json.decode,CmdData)
			if not (status) then
				PrintString("Invalid Json:"..CmdData)
				break
			end
			if 1==CmdType then
				if type(self.m_CmdTypeFunc[Obj.CmdType])~="function" then
					Result=self.m_CmdTypeFunc.Default(self,Obj)
					break
				end
				Result=self.m_CmdTypeFunc[Obj.CmdType](self,Obj)
			elseif 2==CmdType then
				while true do
					if Obj.CmdType=="Login" or Obj.CmdType=="Heartbeat" then
						break
					end
					local Pkt=LxATP.JsonToPkt(CmdData)
					self.Ref.SendPktToServer(Pkt)
					break
				end
			end
		else
			PrintString("Invalid CmdType:"..CmdType)
		end
		break
	end
	PrintString("return:"..(Result or ""))
	return Result or ""
end

function This:SaveUserConfig()
	if LuaPath then
		while true do
			local szJson=json.encode(self.m_UserConfig)
			local WrFile=io.open(LuaPath.."/UserConfig.json","wb")
			if not WrFile then break end
			WrFile:write(szJson)
			io.close(WrFile)
			PrintString("SaveUserConfig")
			break
		end
	end
end

function This:GetDevData(DevID,AutoCreat)
	local DevDataTable=self.Ref.GetDevDataTable()
	local DevData=DevDataTable[DevID]
	if (not DevData) and AutoCreat then
		DevData={
            DaySteps={
                Date="2015-12-29",
                HourSteps={
                    --[0]=0,
                    --[1]=0,
                },
                Status=nil,
            },
        }
		DevDataTable[DevID]=DevData
	end
	return DevData
end

---------------以上区间内的代码为本文件的公共部分，一般无需修改----------------------^

function m_CmdTypeFunc:Test(Obj)
	self.Ref.SqliteTest(Obj)
	return "Test return"
end

function m_CmdTypeFunc:Test1(Obj)
	local Pkt=[[{"DevID":"000F867967022708228F","PktType":"GetDevEventInfo","EventID":"28T1731"}]]
	--Pkt =LxATP.JsonToPkt(Pkt)
	for i=1,500 do	
		self:PutCmdData(2,Pkt)
	end
end

function m_CmdTypeFunc:GetParams(Obj)
	local Result={CmdType="RtGetParams",StatusCode=2,Status="No Data",Params=json.null}	
	if type(self.m_UserConfig.Params)=="table" then
		Result.Params=self.m_UserConfig.Params
		Result.StatusCode=1
		Result.Status="OK"
	end
	Result=json.encode(Result)
	return Result
end

function m_CmdTypeFunc:SetParams(Obj)
	local Result={CmdType="RtSetParams",StatusCode=1,Status="OK"}	
	if type(Obj.Params)=='table' then
		for k,v in pairs(Obj.Params) do
			if App.m_Config[k] then
				App.m_Config[k]=v
			end
			self.m_UserConfig.Params[k]=v
		end
		self:SaveUserConfig()
	end
	Result=json.encode(Result)
	return Result
end

function m_CmdTypeFunc:Login(Obj)
	local Result = [[{"CmdType":"RtLogin","StatusCode":1, "Status":"Process Start"}]]
	while true do
		local Params = self.m_UserConfig.Params
		local IsNeedSaveUserConfig=false
		if (tonumber(Obj.IsRememberPassword) or 0)~=Params.IsRememberPassword then
			Params.IsRememberPassword=(tonumber(Obj.IsRememberPassword) or 0)
			IsNeedSaveUserConfig=true
		end
		if type(Obj.User)=="string" and Obj.User~=Params.User then
			Params.User=Obj.User
			IsNeedSaveUserConfig=true
		end
		if 0==Params.IsRememberPassword then
			if Params.Password~="" then
				Params.Password=""
				IsNeedSaveUserConfig=true
			end
		else
			if type(Obj.Password)=="string" and Obj.Password~=Params.Password then
				Params.Password=Obj.Password
				IsNeedSaveUserConfig=true
			end
		end
		if IsNeedSaveUserConfig then
			self:SaveUserConfig()
		end
		--调用登录命令
		local LoginPkt={PktType="Login",User=Obj.User,Password=Obj.Password,UserType=Obj.UserType,
				No=Obj.No,KickOther=Obj.KickOther,LoginType=Obj.LoginType,LoginClass=Obj.LoginClass}
		LoginPkt=json.encode(LoginPkt)
		LoginPkt =LxATP.JsonToPkt(LoginPkt)
		self.Ref.SendPktToServer(LoginPkt)
		break
	end
	return Result
end

function m_CmdTypeFunc:Logout(Obj)
	local Result = [[{"CmdType":"RtLogout","StatusCode":1, "Status":"Process Start"}]]
	while true do
		local LogoutPkt={PktType="Logout",No=Obj.No}
		LogoutPkt=json.encode(LogoutPkt)
		LogoutPkt =LxATP.JsonToPkt(LogoutPkt)
		self.Ref.SendPktToServer(LogoutPkt)
		break
	end
	return Result
end


function m_CmdTypeFunc:Connect(Obj)
	self.Ref.Connect()
end

function m_CmdTypeFunc:DisConnect(Obj)
	self.Ref.DisConnect()
end

function m_CmdTypeFunc:GetStepsDayInfo(Obj)
	local Comm=Comm
	Comm.AddTaskFun(function()
		local Date=string.sub(Obj.Date,1,10)--2015-10-26
		if not Obj.TimeZone then
			Obj.TimeZone=8
		end
		--准备接收
		local DaySteps=self:GetDevData(Obj.DevID,1)
		DaySteps=DaySteps.DaySteps
		DaySteps.Date=Date
		DaySteps.Status="WaitGetEventList"
		DaySteps.BeginTime=os.time()
		DaySteps.HourSteps={}
		--编写接收到的处理函数
		local FuncProcessRtGetDevLastStatus		
		FuncProcessRtGetDevLastStatus=function(PktObj)
			while true do
				if PktObj.PktType~="RtGetDevLastStatus" then
					break
				end
				self.Ref.SetRxFunc(FuncProcessRtGetDevLastStatus,nil)		
				local UpdateTime=PktObj.DevLastStatus.DaySteps.UpdateTime
				if type(UpdateTime)=="string" then
					UpdateTime=TimeZoneAdd(UpdateTime,Obj.TimeZone)
					if UpdateTime and DaySteps.Date==string.sub(UpdateTime,1,10) then					
						local Hour=tonumber(string.sub(UpdateTime,12,13))--"2015-07-23 12"
						DaySteps.HourSteps[Hour]=PktObj.DevLastStatus.DaySteps.Steps
					end
				end
				local HourSteps=DaySteps.HourSteps
				local LocalDaySteps={}

				HourSteps[0]=HourSteps[0] or 0
				table.insert(LocalDaySteps,HourSteps[0])
				for i=1,23 do
					HourSteps[i]=HourSteps[i] or HourSteps[i-1]
					local Val=HourSteps[i]-HourSteps[i-1]
					table.insert(LocalDaySteps,Val<0 and 0 or Val)
				end
				local TxObj={
					No=Obj.No,
					CmdType="RtGetStepsDayInfo",
					StatusCode=0,
					Status="OK",
					StepsDayInfo={
						DevID=Obj.DevID,
						Date=Obj.Date,
						DaySteps=LocalDaySteps
					}
				}
				local SendStr=json.encode(TxObj)
				if SendStr then
					self.Ref.CallBackOnReceive(1,SendStr)
				end
			break end
		end
		---------------------------
		local FuncProcessRtGetDevEventInfo
		local LastEventID=nil
		FuncProcessRtGetDevEventInfo=function(PktObj)
			while true do
				if PktObj.PktType~="RtGetDevEventInfo" then
					break
				end
				local EventInfo=PktObj.EventInfo
				if EventInfo.EventID==LastEventID then
					self.Ref.SetRxFunc(FuncProcessRtGetDevEventInfo,nil)
				end
				local MsgObj=json.decode(EventInfo.MsgData)
				--{PktType="HourSteps",TimeHour=HourSteps.TimeHour,DevID=TaskObj.DevID,Steps=HourSteps.Steps}
				if MsgObj.PktType=="HourSteps" then
					local Hour=Obj.TimeZone+tonumber(string.sub(MsgObj.TimeHour,12,13))--"2015-07-23 12"
					DaySteps.HourSteps[Hour]=MsgObj.Steps
				end
				--读最新的状态
				if EventInfo.EventID==LastEventID then
					self.Ref.SetRxFunc(FuncProcessRtGetDevLastStatus,true)					
					local Pkt=[[{"PktType":"GetDevLastStatus","DevID":"%s"}]]
					Pkt=string.format(Pkt,Obj.DevID)
					Pkt=LxATP.JsonToPkt(Pkt)
					self.Ref.SendPktToServer(Pkt)
				end
			break end
		end
		----------------------
		local FuncProcessRtGetDevEventListByTime
		FuncProcessRtGetDevEventListByTime=function(PktObj)
			while true do
				if PktObj.PktType~="RtGetDevEventListByTime" then
					break
				end
				if 0==PktObj.StatusCode and PktObj.ListCount>0 then--并且有数据				
					for i,v in ipairs(PktObj.EventIDList) do
						local Pkt=string.format([[{"PktType":"GetDevEventInfo","EventID":"%s"}]],v)
						Pkt=LxATP.JsonToPkt(Pkt)
						self.Ref.SendPktToServer(Pkt)
						LastEventID=v
					end
					self.Ref.SetRxFunc(FuncProcessRtGetDevEventInfo,true)
				else
					self.Ref.SetRxFunc(FuncProcessRtGetDevLastStatus,true)					
					local Pkt=[[{"PktType":"GetDevLastStatus","DevID":"%s"}]]
					Pkt=string.format(Pkt,Obj.DevID)
					Pkt=LxATP.JsonToPkt(Pkt)
					self.Ref.SendPktToServer(Pkt)
				end
				self.Ref.SetRxFunc(FuncProcessRtGetDevEventListByTime,nil)
			break end
		end
		self.Ref.SetRxFunc(FuncProcessRtGetDevEventListByTime,true)
		--发送查询指令
		local Pkt=[[{"PktType":"GetDevEventListByTime","DevID":"%s","StartTime":"%s","EndTime":"%s","StartIndex":0,"LimitNum":30,"EventClass":3}]]
		local TimeBegin=TimeZoneAdd(Date.." 00:00:00",0-Obj.TimeZone)
		local TimeEnd=TimeZoneAdd(Date.." 23:59:59",0-Obj.TimeZone)
		Pkt=string.format(Pkt,Obj.DevID,TimeBegin,TimeEnd)
		Pkt =LxATP.JsonToPkt(Pkt)
		self.Ref.SendPktToServer(Pkt)
	end)
	local Result=""
	return Result
end

function m_CmdTypeFunc:VirtualDev(Obj)
	if 1==Obj.Open then
		self.Ref.VirtualDevCtrl({Cmd="Open"})
	elseif 0==Obj.Open then
		self.Ref.VirtualDevCtrl({Cmd="Close"})
	end
end

function m_CmdTypeFunc:SendPosition(Obj)
	self.Ref.VirtualDevCtrl({Cmd="SendPosition",Position=Obj.Position})
end

function m_CmdTypeFunc:Default(Obj)
	local Comm=Comm
	Comm.AddTaskFun(function()
		local Timer=Comm.NewTimer()
		Comm.YieldSleep(100,Timer)
		local SendStr=nil
		local TxObj = {
			No=Obj.No,
			CmdType="Rt"..(Obj.CmdType or "CmdType=nil"),
			StatusCode=1,
			Status="Unknow CmdType",
		}
		SendStr=json.encode(TxObj)
		if SendStr then
			self.Ref.CallBackOnReceive(1,SendStr)
		end
	end)
end


--蓝牙多基站定位
local BtBaseMap={
	["<BtBaseID>"]={--示例
        BtBaseID= "000F867967022778247F",
        MapID= "xxxxxx",
        X= 120.2,
        Y= 333.8
	}
}

local BtDeviceBtBaseList={
	["<DEVID>"]={--示例
		{
			IntTime=12334344,
			BtBaseID="000F867967022778247F",
			Signal=-96
		},
		{
			IntTime=12334344,
			BtBaseID="000F867967022778247F",
			Signal=-93
		},
	}
}

local BtDeviceLastLocation={
	["<DEVID>"]={--示例
		DevID="863874484",
		MapID="MapIDUse",
		X=21.233,
		Y=98.33,
	}
}

--[[--此为原始的，多基站定位算法，后来改进了，此不用了。
local function BtGetLocation(pArry)
	local pOut = {
		CoordX = 0,
		CoordY = 0,
		Radius = 0,
	}
    local NumInArry = #pArry
    local sum = 0.0					--定义总强度	
    local Signal_RSSI = {}			--转换信号强度
    local R = {}					--定义接收信号强度比值数组
    local W = {}					--定义权值数组
    local sum_W = 0.0				--定义权值和
    local sum_x = 0.0				--定义加权和x
    local sum_y = 0.0				--定义加权和y
    local i = 0
    --RSSI转化
    --算平均信号dbm
    local fpAvgRssi = 0.0
    for k,v in pairs(pArry) do
    	fpAvgRssi = fpAvgRssi+v.Strength
    end
    fpAvgRssi = fpAvgRssi / NumInArry
    --算基站的坐标范围
    local LonL, LonH
    local LatL, LatH
    local Lon, Lat
    LonL = pArry[1].CoordX
    LonH = LonL
    LatL = pArry[1].CoordY
    LatH = LatL
    for k,v in pairs(pArry) do
    	Lon = v.CoordX
        Lat = v.CoordY
        if Lon > LonH then
            LonH = Lon
        elseif Lon < LonL then
            LonL = Lon
        elseif Lat > LatH then
            LatH = Lat
        elseif Lat < LatL then
            LatL = Lat
        end
    end

    for k,v in pairs(pArry) do
        Signal_RSSI[k] = (v.Strength + 113.0) / 2--103:265,113:264,118:265,123:267
        Signal_RSSI[k] = Signal_RSSI[k]^2 --2,2643,2671.5,2671.8,265
    end

	--计算所有接收强度之和
    for k,v in pairs(Signal_RSSI) do
    	sum = sum+v
    end

    --如果接受强度为零，无法计算坐标，返回-1

    if sum > 0 and sum <= 1e-15 then
        return null
    elseif sum < 0 and (0 - sum) <= 1e-15 then
        return null
    end

    --	if (Math.Abs(sum) <= 1e-15)			
    --		return -1

    --计算权值，理论详细解释可查看文献《一种改进的加权质心定位算法_杨新宇》
    if NumInArry == 1 then
        W[1] = pArry[1].Strength / sum	--若只有一个基站，权值需要进一步确定；
        --	--将考虑两点因素：1建立距离和强度的衰减函数，来确定权值；2或是如何确定几个合适的虚拟基站来估算
    else
    	for k,v in pairs(Signal_RSSI) do
    		W[k] = v / (sum - v)
    	end
    end

    --计算权值和
    for k,v in pairs(W) do
    	sum_W = sum_W + v
    end

    --计算加权和
    for k,v in pairs(pArry) do
    	sum_x = sum_x + v.CoordX * W[k]
    end

    for k,v in pairs(pArry) do
    	sum_y = sum_y+v.CoordY * W[k]
    end

    --计算坐标
    pOut.CoordX = sum_x / sum_W
    pOut.CoordY = sum_y / sum_W

    return pOut
end
--]]

local function BtCalcWeight(Strength,BeforSecTime)
	local Weight=0
	local StrengthWeight={
		{-40,100},
		{-50,70},
		{-60,50},
		{-70,30},
		{-90,20},
		{-120,0},
	}
	local WeightPrev,StrengthPrev=nil
	for i,v in ipairs(StrengthWeight) do
		local CurStrength,CurWeigth=v[1],v[2]
		if not WeightPrev then
			StrengthPrev=CurStrength
			WeightPrev=CurWeigth
		end
		if Strength>CurStrength then
			if (StrengthPrev-CurStrength)==0 then
				Weight=CurWeigth
			else
				Weight=CurWeigth+(WeightPrev-CurWeigth)*(Strength-CurStrength)/(StrengthPrev-CurStrength)
			end
			break
		end
		StrengthPrev=v[1]
		WeightPrev=v[2]
	end
	--权重根据超时值再乘以系数
	local P=(100-BeforSecTime)
	if P<0 then
		P=0
	else
		P=P*0.01
	end
	Weight=Weight*P
	return Weight
end

local function BtGetLocation(Arry)
	--{{X=22,Y=11,W=97.4},{X=-12,Y=22,W=32}}--X值，Y值，权重
	local Out={X=0,Y=0}
	local SumWeight=0
	local SumXmutW=0
	local SumYmutW=0
	for i,v in ipairs(Arry)do
		local W=v.W
		SumWeight=SumWeight+W
		SumXmutW=SumXmutW+W*v.X
		SumYmutW=SumYmutW+W*v.Y
	end
	if SumWeight>0 then
		Out.X=SumXmutW/SumWeight
		Out.Y=SumYmutW/SumWeight
	end
	return Out
end

--从设备来的报文中获取DevID。
local function GetPktDevID(Pkt)
	local DevID = ""
	local ID_Type = string.byte(Pkt,7)
	local ID_Len =  string.byte(Pkt,8)
	if 0==ID_Type then--0x00:表示ID号每两位用一个字节表示。
		ID_Len=math.modf((ID_Len+1)/2)
		DevID=string.sub(Pkt,7,8+ID_Len)
		DevID=string.bin2hex(DevID)
	elseif 1==ID_Type then--0x01:表示ID号每一位用一个字节表示。
		DevID=string.sub(Pkt,7,8+ID_Len)
		DevID=string.bin2hex(DevID)
	end
	return DevID
end

--返回设备ID字段点的字节数
local function GetPktDevIDLen(Pkt)
	local ID_Type = string.byte(Pkt,7)
	local ID_Len =  string.byte(Pkt,8)
	if 0==ID_Type then--0x00:表示ID号每两位用一个字节表示。
		ID_Len=math.modf((ID_Len+1)/2)
	elseif 1==ID_Type then--0x01:表示ID号每一位用一个字节表示。
	end
	return ID_Len+2
end

function m_CmdTypeFunc:BtSetMapList(Obj)
	BtBaseMap={}
	for k,v in pairs(Obj.MapList or {}) do
		BtBaseMap[v.BtBaseID]=v
	end
	local Result=[[{"CmdType":"RtBtSetMapList","StatusCode":0,"Status":"OK"}]]
	return Result
end

function m_CmdTypeFunc:BtUpdateScanDevList(Obj)
	local Pkt=string.hex2bin(Obj.RawPkt)
	local AFN=string.bin2hex(string.sub(Pkt,5,6))
	if AFN~="A148" then
		return '{"CmdType":"BtUpdateScanDevList","StatusCode":1,"Status":"Not A148 Pkt"}'
	end
	local IDLen=GetPktDevIDLen(Pkt)
	local BtBaseID=GetPktDevID(Pkt)
	local Y,m,d,H,M,S = string.match(Obj.Time,"(%d+)-(%d+)-(%d+) (%d+):(%d+):(%d+)")
	local IntTime=os.time{year=tonumber(Y), month=tonumber(m), day=tonumber(d), hour=tonumber(H),min=tonumber(M),sec=tonumber(S)}
	local ScanList=string.sub(Pkt,IDLen+7,-5)
	--解析ScanList基站和信号强度
	local List={}
	ScanList=string.split(ScanList or "",";")
	for i,v in ipairs(ScanList or {}) do
		local p=string.split(v or "",",")
		if p and #p[1]==15 then
			table.insert(List,{
				DevID="000F"..p[1].."F",
				Signal=tonumber(p[2]),
			})
		end
	end
	--将基站扫描到的设备更新到设备最新对应基站里
	for i,v in ipairs(List) do
		local t=BtDeviceBtBaseList[v.DevID]
		if not t then
			t={}
			BtDeviceBtBaseList[v.DevID]=t
		end
		if #t>4 then
			table.remove(t,4)
		end
		table.insert(t,1,{
			IntTime=IntTime,
			BtBaseID=BtBaseID,
			Signal=v.Signal,
		})
	end
	--生成设备位置更新列表
	local DevList={}--{DevID=xxx,MapID=xx,X=xxx,Y=xx}
	for i,v in ipairs(List) do
		local t=BtDeviceBtBaseList[v.DevID]
		local Param={}
		local MapIDUse=nil
		for i1,v1 in ipairs(t) do
			local Diff=IntTime-v1.IntTime
			if Diff<0 then
				Diff=0
			end
			local Weight=BtCalcWeight((v1.Signal or -80),Diff)
			local BtBaseInfo=BtBaseMap[v1.BtBaseID]
			if BtBaseInfo then
				local CoordX=BtBaseInfo.X
				local CoordY=BtBaseInfo.Y
				local MapID=BtBaseInfo.MapID
				if not MapIDUse then
					MapIDUse=MapID
				end
				if MapIDUse==MapID then
					table.insert(Param,{
						X = CoordX,
						Y = CoordY,
						W = Weight,
					})
				end
			end
		end
		if MapIDUse then
			local Rt=BtGetLocation(Param)
			local Location={
				DevID=v.DevID,
				MapID=MapIDUse,
				X=Rt.X,
				Y=Rt.Y,
				Time=os.date("%Y-%m-%d %H:%M:%S",IntTime),
			}
			table.insert(DevList,Location)
			BtDeviceLastLocation[v.DevID]=Location
		end
	end
	if #DevList==0 then
		DevList=nil
	end
	local Rt=json.encode({CmdType="BtUpdateScanDevList",DevList=DevList})
	return Rt
end

function m_CmdTypeFunc:BtGetDevInMap(Obj)
	local DevList={}
	for i,v in ipairs(Obj.DevList) do
		local Location=BtDeviceLastLocation[v.DevID]
		table.insert(DevList,Location)
	end
	if #DevList==0 then
		DevList=nil
	end	
	local Rt={
		CmdType="RtBtGetDevInMap",
		DevList=DevList,
	}
	return json.encode(Rt)
end
