
local NetTool_CLS=require("NetTool")

local This
if App then
	This=App.m_VirtualDevice
else
	This={} --方便单文件检测语法错误
end

function This:Init()
	self.m_Data={}
	local Comm=Comm
	--处理发位置信息
	Comm.AddTaskFun(function()
		local Timer=Comm.NewTimer()
		--Comm.YieldSleep(100,Timer)
		local m_Data=self.m_Data
		while true do
			local Interval=m_Data.Interval
			if type(Interval)~="number" then
				Interval=10
			end
			if Interval<10 then
				Interval=10
			end
			--
			Timer:UpdateTimer()
			while Timer:GetTimerMsec()<(Interval*1000) do
				coroutine.yield()
				Timer:UpdateTimer()
			end
			Timer:ResetTimer()
			--判断是否应该发
			if m_Data.IsOpen then
				--如果没有接连服务器，先连接
				local is=self:IsConnect()
				if not is then
					self:YieldConnectServer()
				end
				local SendStr=nil
				local TxObj = {
					CmdType="NotifySendPosition",
				}
				SendStr=json.encode(TxObj)
				if SendStr then
					self.Ref.CallBackOnReceive(1,SendStr)
				end
			end
		end
	end)
	--处理接收
	Comm.AddTaskFun(function()
		while true do
			local NetClient=self.m_Data.m_NetClient
			if NetClient then
				local _,IsConnectOK=NetClient:GetOutput()
				while 1==IsConnectOK do
					while true do--接收数据并处理
						local Rx=NetClient:GetData()
						if string.len(Rx)~=0 then
							self:OnRxData(Rx)
							NetClient:OnTime()
						else
							break
						end
					end
					_,IsConnectOK=NetClient:GetOutput()
					if 0==IsConnectOK then
						PrintString("Dev TCP Break Down")
						self.m_Data.m_NetClient=nil
						break
					end
					coroutine.yield()
				end				
			end
			coroutine.yield()
		end
	end)
end

function This:OnTime()

end

function This:Register()	
	while true do
		local Pkt={PktType="RegisterVirtualDev"}
		Pkt=json.encode(Pkt)
		Pkt=LxATP.JsonToPkt(Pkt)
		self.Ref.SendPktToServer(Pkt)
	break end
end

function This:Open()
	local m_Data = self.m_Data
	m_Data.IsOpen=true
	--重新获取设备的DevID
	m_Data.DevID=nil
	if not m_Data.DevID then
		local FuncProcessRtRegisterVirtualDev
		FuncProcessRtRegisterVirtualDev=function(PktObj)
			local Rt=nil
			if PktObj.PktType=="RtRegisterVirtualDev" then
				if type(PktObj.DevID)=="string" then
					m_Data.DevID=PktObj.DevID
				end
				self.Ref.SetRxFunc(FuncProcessRtRegisterVirtualDev,nil)
				Rt=true --表示此报文已被处理，不再发到应用层处理
			end
			return Rt
		end
		local FuncProcessRtGetVirtualDevID
		FuncProcessRtGetVirtualDevID=function(PktObj)
			local Rt=nil
			if PktObj.PktType=="RtGetVirtualDevID" then
				if type(PktObj.DevID)=="string" then
					m_Data.DevID=PktObj.DevID
				else
					local Pkt=LxATP.JsonToPkt([[{"PktType":"RegisterVirtualDev"}]])
					self.Ref.SendPktToServer(Pkt)
					self.Ref.SetRxFunc(FuncProcessRtRegisterVirtualDev,true)
				end
				self.Ref.SetRxFunc(FuncProcessRtGetVirtualDevID,nil)
				Rt=true --表示此报文已被处理，不再发到应用层处理
			end
			return Rt
		end
		self.Ref.SetRxFunc(FuncProcessRtGetVirtualDevID,true)
		--发送GetVirtualDevID
		local Pkt={PktType="GetVirtualDevID"}
		Pkt=json.encode(Pkt)
		Pkt=LxATP.JsonToPkt(Pkt)
		self.Ref.SendPktToServer(Pkt)
	end
	Comm.AddTaskFun(function()
		self:YieldConnectServer()
	end)
end

function This:Close()
	self.m_Data.IsOpen=false
	if self.m_Data.m_NetClient then
		self.m_Data.m_NetClient:Close()
	end
end

function This:SendPosition(Position)	
	local m_Data=self.m_Data
	while true do
		if not m_Data.IsOpen then
			break
		end
		if type(m_Data.DevID)~="string" then
			break
		end
		local is=self:IsConnect()
		if not is then
			break
		end
		---
		local Lat,Lon=Position.Lat,Position.Lng
		Lat=Lat+0.00000000001
		Lon=Lon+0.00000000001
		local LatA,LatB=math.modf(Lat)
		local LatB,LatC=math.floor(LatB*60),math.mod(LatB*60*10000,10000)
		local LonA,LonB=math.modf(Lon)
		local LonB,LonC=math.floor(LonB*60),math.mod(LonB*60*10000,10000)
		--生成时间
		local Time=os.date("*t", os.time()-28800)
		--生成TimeLatLon数据
		local TimeLatLon=string.format("%02d%02d%02d.%03d,A,%02d%02d.%04d,N,%03d%02d.%04d,E",
		Time.hour,Time.min,Time.sec,995,
		LatA,LatB,LatC,LonA,LonB,LonC)
		--print(TimeLatLon)
		--生成Knots为单位的速度,Heading,Alt
		local Speed=0.01
		if Position.Speed then
			--m/s转knots/h
			Speed=Position.Speed/0.514444
		end
		local Heading=Position.Course or 0
		local Alt=Position.Alt or 0.01
		--生成SpeedHeadDate
		local SpeedHeadDate=string.format("%0.3f,%0.2f,%02d%02d%02d",
				Speed,Heading,
				Time.day,
				Time.month,
				math.mod(Time.year,100)
			)
		--生成
		--"100008.000,A,2232.4679,N,11356.7805,E,0.204,89.22,210911,,|7.49|%0.1f|3571,9763,00,460|0000|00|100|100"
		local Data="%s,%s,,|7.49|%0.1f|3571,9763,00,460|0000|00|100|100"
		Data=string.format(Data,TimeLatLon,SpeedHeadDate,Alt)
		--print(Data)
		local TxPkt=LxATP.RawDataToPkt(string.hex2bin("A120"..m_Data.DevID)..Data,'$')
		--TxPkt=string.bin2hex(TxPkt)
		--发送数据
		local NetClient =m_Data.m_NetClient
		NetClient:PutData(TxPkt)
	break end
end

function This:YieldConnectServer()
	local Server,Port=self.Ref.GetServerAddr()
	--域名解析
	local DomainIP=NetTool_CLS:YieldParseNetAddr(Server)
	--连接服务器
    local NetClient=mx.mxNetClient_CLS()
    NetClient:Init(Comm.GetTimeMsec())
    NetClient:SetInput(DomainIP,Port)
    NetClient:Open()
    self.m_Data.m_NetClient=NetClient
    --等待连接成功
   	local TimerMsec=Comm.NewTimer()
    local IsConnectOK=0
    TimerMsec:ResetTimer()
    while true do
        NetClient:OnTime()
        _,IsConnectOK=NetClient:GetOutput()
        if IsConnectOK>0 then
            break
        end
        TimerMsec:UpdateTimer()
        if TimerMsec:GetTimerMsec()>10000 then
            break
        end
        coroutine.yield()
    end
end

function This:IsConnect()
	local NetClient=self.m_Data.m_NetClient
	local IsConnectOK=0
	if NetClient then
		_,IsConnectOK=NetClient:GetOutput()
	end
	if 1==IsConnectOK then
		IsConnectOK=true
	else
		IsConnectOK=false
	end
	return IsConnectOK
end

function This:OnRxData(Data)
	local RxData=(self.m_RxData or "")..Data
	while true do
		if string.len(RxData)<10 then
			break
		end
		local LenH,LenL=string.byte(RxData,3,4)
		local Len=LenH*256+LenL	
		local Header=string.sub(RxData,1,2)			
		if Len<10 or (Header~="$$" and Header~="@@") then
			RxData=string.sub(RxData,2,-1)--数据去掉一字节
			PrintString("Get Error Pkt Header")
		else
			if string.len(RxData)<Len then--等到收齐报文数据
				break
			end
			local Pkt = string.sub(RxData,1,Len)
			RxData=string.sub(RxData,Len+1,-1)
			self:OnRxPkt(Pkt)			
		end
	end
	self.m_RxData=RxData
end

function This:OnRxPkt(Pkt)

end

function This:VirtualDevCtrl(CtrlObj)
	local Cmd=CtrlObj.Cmd
	if "Open"==Cmd then
		self:Open()
	elseif "Close"==Cmd then
		self:Close()
	elseif "Register"==Cmd then
		self:Register()
	elseif "SendPosition"==Cmd then
		self:SendPosition(CtrlObj.Position)
	end
end
